import java.net.*;
import java.io.*;
import java.util.*;


public class client {
	private static final Scanner SCANNER = new Scanner(System.in);

	public static void main(String args[]) throws IOException, InterruptedException {
		InetAddress address = InetAddress.getLocalHost();
		Socket sock = null;
		InputStreamReader sockin = null;
		BufferedReader buff = null;
		PrintWriter out = null;

		try {
			sock = new Socket(address, 1776);
			sockin = new InputStreamReader(sock.getInputStream());
			buff = new BufferedReader(sockin);
			out = new PrintWriter(sock.getOutputStream());
		} catch (IOException e) {
			e.printStackTrace();
			System.err.print("IO Exception");
		}
		System.out.println("Client Address : " + address + "\n");
		/* GAME LOOP STARTS BELOW */
		try {
			buff = new BufferedReader(sockin);
			String str;
			String [] str_array;
			while (true) {
				System.out.println("HERE");
				str = buff.readLine();				// RECIEVE SELECTOR SIGNAL

				System.out.println(str);
				if(str.equals("SELECTOR"))
				{
					System.out.println("PLEASE SELECT A CATEGORY: \n1 for Geography\n2 for History\n3 for Movies&TV\n4 for Mythology\n5 for Science\n6 for Sports");
					out.println(SCANNER.nextLine());
					out.flush();
				}
				str = buff.readLine();				// READ QUESTION
				str_array = str.split(","); 		// SPLIT CSV
				str_array = shuffle(str_array);		// SHUFFLE ANSWER ORDER
				print_question(str_array);			// PRINT QUESTION (currently to terminal)

				out.println(SCANNER.nextLine());	// This just probes for keyboard input, will be changed to probe for clicking/pressing on the answer buttons later
				out.flush();						// SEND ANSWER

				// while(!buff.ready()) { Thread.sleep(500); }	// WAIT FOR DATA TO COME IN
				System.out.print(buff.readLine());	// DISPLAY RESULTS

				str = buff.readLine();
				str_array = str.split(",");
				print_scoreboard(str_array);
				System.out.flush();
				
				//break;
			}
		} catch(IOException e) {
				e.printStackTrace();
				System.out.println("Socket read Error");
		}
		finally{
			buff.close();out.close();sockin.close();sock.close();
					System.out.println("Connection Closed");
		}
	}

	private static String[] shuffle(String[] str_array) {
		String question = str_array[0];
		for (var i = str_array.length - 1; i > 0; i--) {
			var j = Math.floor(Math.random() * (i + 1));
			var temp = str_array[i];
			str_array[i] = str_array[(int)j];
			str_array[(int)j] = temp;
		}
		int  i = 0;
		boolean keepgoing = true;
		String temp;
		while (keepgoing)
		{
			if (str_array[i] == question)
			{
				temp = str_array[0];
				str_array[0] = question;
				str_array[i] = temp;
				keepgoing = false;
			}
			i++;
		}
		return str_array;
	  }
	private static void print_question(String[] str_array) {
		System.out.print("\nQUESTION: " + str_array[0] + "\na: " + str_array[1] + "\nb: " + str_array[2] + "\nc: " + str_array[3] + "\nd: " + str_array[4] + "\n");
	}

	private static void print_scoreboard(String[] str_array) {
		System.out.println(); System.out.println();
		for(String str : str_array)
		{	System.out.println(str);	}	
	}
}