import java.net.*;
import java.util.*;
import java.io.*;

public class server {
	static ArrayList<ServerThread> al = new ArrayList<ServerThread>();
	static ArrayList<Queue<String>> ql = new ArrayList<Queue<String>>();
	public static void main(String args[]) throws IOException {
		initialize_questions();
		ServerSocket s_sock = null;
		System.out.println("Waiting...");
		try {
			s_sock = new ServerSocket(1776);
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("Server error");
		}
		while (true) {
			main_server_run(s_sock); // Establishes socket connections
			/*
			 * for (ServerThread i : al) { I don't think this is necessary and I think it was
			 * causing problems i.run(); }
			 */
		}
	}
	
	private static void initialize_questions() throws IOException 
	{
		String[] file_name_list = {"Geography.txt", "History.txt", "Movies&TV.txt", "Mythology.txt", "Science.txt", "Sports.txt"};
		for (String file_name : file_name_list)
		{
			Queue<String> q = new PriorityQueue<String>();

			File f = new File("questions/"+file_name);
			BufferedReader buff = null;
			buff = new BufferedReader(new FileReader(f));
			System.out.print("Loading: " + f.getName() + "\n");
			while(buff.ready())
			{	q.add(buff.readLine());	}	// WRITES THE CONTENTS OF FILE TO Q
			ql.add(q);						// ADDS Q TO LIST OF Q'S
			buff.close();
		}
		for (Queue<String> x : ql)			// Randomizes the order of the questions in the queues one category at a time
		{
			Object[] array = x.toArray();
			for (var i = x.size() - 1; i > 0; i--) {
				var j = Math.floor(Math.random() * (i + 1));
				var temp = array[i];
				array[i] = array[(int)j];
				array[(int)j] = temp;
			}
			int orig_size = x.size();
			for (int i = 0; i < orig_size; i++)
			{
				x.remove();
			}
			for(Object i : array)
			{
				x.add((String) i);
			}
		}
	}

	static void main_server_run(ServerSocket s_sock) {
		Socket sock = null;
		try {
			sock = s_sock.accept();
			System.out.println("\nCLIENT CONNECTED");
			ServerThread st = new ServerThread(sock, al.size() + 1, al, ql);
			al.add(st);
			System.out.println(al.size());
			st.start();
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("Connection Error");
		}
	}
}

class ServerThread extends Thread {
	ArrayList<ServerThread> al;
	ArrayList<Queue<String>> ql;
	Socket sock = null;
	int id;
	boolean done;
	boolean ready;
	boolean selector;
	boolean loop;

	InputStreamReader sockin = null;
	BufferedReader buff = null;
	PrintWriter sockout = null;
	int point_total;
	int round_points;
	String question;


	public ServerThread(Socket sock, int x, ArrayList<ServerThread> y, 
											ArrayList<Queue<String>> z) 
	{// ServerThread Constructor
		this.sock = sock;
		this.id = x;
		this.al = y;
		this.ql = z;

		this.point_total = 0;
		this.round_points = 0;
	}

	public synchronized void run() {
		try {
			while (this.getThreadGroup().activeCount() < 3) { } 		// Waits for n - 1 people to join the game
			point_total = 0;											// Starts points at 0

			if (this.id == 1)											// Player one is first selector
			{	selector = true;	}
			else
			{	selector = false;	}
			/* GAME LOOP STARTS BELOW */
			boolean forever = true; ready = false; done = false;		// Init flags
			while (forever) { 
				sockout = new PrintWriter(sock.getOutputStream());		// ESTABLISHES CONNECTION TO SOCKET OUTPUT
				sockin = new InputStreamReader(sock.getInputStream());	// ESTABLISHES CONNECTION TO SOCKET INPUT
				buff = new BufferedReader(sockin); 						// CONNECTS BUFFEREDREADER TO SOCKET INPUT

				if (selector == true)									// IF THIS THREAD'S CLIENT HAS BEEN CHOSEN TO SELECT NEXT CATEGORY:
				{
					sockout.println("SELECTOR");
					sockout.flush();
					int index = Integer.parseInt(buff.readLine()) - 1;	// RECIEVES THE QUEUE TO PEEK ON FROM THE CLIENT
					question = ql.get(index).peek();					// GETS NEXT QUESTION
					System.out.println(question);
					for (ServerThread x : al)
					{	x.question = question;	}						// SENDS QUESTION TO EVERY THREAD
					ql.get(index).remove();								// REMOVES THE QUESTION FROM THAT QUEUE TO PREVENT DUPLICATE QUESTIONS
				}
				else
				{	sockout.println("NO"); sockout.flush();	}

				/*------------------------------------------------------------------------------------------------------------------------*/
				ready = true;											// WAITS FOR THREADS TO BE READY TO MOVE ON FROM CATEGORY SELECTION
				loop = true;
				while(loop)												
				{	loop = false;
					for(ServerThread x : al)
					{	if (!x.ready)
						{	loop = true;	}	}	}
				/*------------------------------------------------------------------------------------------------------------------------*/
				done = false;	// Reset the next flag

				sockout.println(question); 								// WRITES QUESTION TO SOCKET
				sockout.flush();										// SEND IT

				String answer = buff.readLine();						// READS ANSWER TO STR
				String [] q = question.split(",");						// SPLITS THE ORIGINAL QUESTION

				if (q[1].equals(answer))								// Correct answer is stored in q[1]
				{ 
					round_points = 100; 
					sockout.println("YOU'RE CORRECT! + " + round_points + "!");
					sockout.flush();  
				}
				else 
				{ 
					round_points = 0;
					sockout.println("YOU'RE WRONG!"); 
					sockout.flush(); 
				}
				point_total = point_total + round_points;				// POINT TOTAL CHANGE
				System.out.print("\nYOU ANSWERED: " + answer + " + " + round_points + "\nYOUR TOTAL POINTS: " + point_total + "!\n\n");
				
				/*------------------------------------------------------------------------------------------------------------------------*/
				done = true;											// WAITS FOR THREADS TO BE DONE COMMUNICATING ANSWERS & TOTALING POINTS
				loop = true;
				while(loop)												
				{	loop = false;
					for(ServerThread x : al)
					{	if (!x.done)
						{	loop = true;	}	}	}
				/*------------------------------------------------------------------------------------------------------------------------*/
				ready = false; // Reset the next flag
				
				for (ServerThread x : al)								// GETS EVERYONE'S SCORE & SENDS THEM TO CLIENT		
				{	
					sockout.print("PLAYER " + x.id + "SCORE: " + x.point_total + ",");
				}
				sockout.println();
				sockout.flush();
				//break;
			}  
		} 
		catch (IOException e) {
			System.out.println("IO Error/ Client " + this.getName() + " terminated abruptly");
		}
		catch(NullPointerException e){
			System.out.println("Client " + this.getName() + " Closed");
		}
		/* finally {    
			try
			{
				System.out.println("Connection Closing..");
				if (buff != null){
					buff.close(); 
					System.out.println(" Socket Input Stream Closed");
				}
				if(sockout!=null){
					sockout.close();
					System.out.println("Socket Out Closed");
				}
				if (sock != null){
				sock.close();
				System.out.println("Socket Closed");
				}
			} catch(IOException ie){
				System.out.println("Socket Close Error");
			}
		} */ /*end finally*/}
}